<html>
<head>
<title>OgreRibbonTrail.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreRibbonTrail.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreRibbonTrail_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __RibbonTrail_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __RibbonTrail_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreBillboardChain_8h.html">OgreBillboardChain.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreNode_8h.html">OgreNode.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreFrameListener_8h.html">OgreFrameListener.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="OgreControllerManager_8h.html">OgreControllerManager.h</a>&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">namespace </span>Ogre {
<a name="l00041"></a>00041 
<a name="l00070"></a><a class="code" href="classOgre_1_1RibbonTrail.html">00070</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RibbonTrail.html" title="Subclass of BillboardChain which automatically leaves a trail behind one or more Node instances...">RibbonTrail</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1BillboardChain.html" title="Allows the rendering of a chain of connected billboards.">BillboardChain</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>::<a class="code" href="classOgre_1_1MovableObject_1_1Listener.html" title="Listener which gets called back on MovableObject events.">Listener</a>
<a name="l00071"></a>00071     {
<a name="l00072"></a>00072     <span class="keyword">public</span>:
<a name="l00082"></a>00082         <a class="code" href="classOgre_1_1RibbonTrail.html" title="Subclass of BillboardChain which automatically leaves a trail behind one or more Node instances...">RibbonTrail</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">size_t</span> maxElements = 20, <span class="keywordtype">size_t</span> numberOfChains = 1, 
<a name="l00083"></a>00083             <span class="keywordtype">bool</span> useTextureCoords = <span class="keyword">true</span>, <span class="keywordtype">bool</span> useColours = <span class="keyword">true</span>);
<a name="l00085"></a>00085         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1RibbonTrail.html" title="Subclass of BillboardChain which automatically leaves a trail behind one or more Node instances...">RibbonTrail</a>();
<a name="l00086"></a>00086 
<a name="l00087"></a><a class="code" href="classOgre_1_1RibbonTrail.html#a2014374dc138cc1cc5dfc21c636bd86a">00087</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Node*&gt;::type</a> <a class="code" href="classOgre_1_1RibbonTrail.html#a2014374dc138cc1cc5dfc21c636bd86a">NodeList</a>;
<a name="l00088"></a><a class="code" href="classOgre_1_1RibbonTrail.html#aa87dbc42370145c7829bce54b0919e03">00088</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">ConstVectorIterator&lt;NodeList&gt;</a> <a class="code" href="classOgre_1_1RibbonTrail.html#aa87dbc42370145c7829bce54b0919e03">NodeIterator</a>;
<a name="l00089"></a>00089 
<a name="l00093"></a>00093         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addNode(<a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* n);
<a name="l00095"></a>00095         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeNode(<a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* n);
<a name="l00097"></a>00097         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">NodeIterator</a> getNodeIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00099"></a>00099         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> getChainIndexForNode(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* n);
<a name="l00100"></a>00100 
<a name="l00107"></a>00107         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setTrailLength(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> len);
<a name="l00109"></a><a class="code" href="classOgre_1_1RibbonTrail.html#a4595986e9545416094326bec34d83cba">00109</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1RibbonTrail.html#a4595986e9545416094326bec34d83cba" title="Get the length of the trail.">getTrailLength</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mTrailLength; }
<a name="l00110"></a>00110 
<a name="l00112"></a>00112         <span class="keywordtype">void</span> setMaxChainElements(<span class="keywordtype">size_t</span> maxElements);
<a name="l00114"></a>00114         <span class="keywordtype">void</span> setNumberOfChains(<span class="keywordtype">size_t</span> numChains);
<a name="l00116"></a>00116         <span class="keywordtype">void</span> clearChain(<span class="keywordtype">size_t</span> chainIndex);
<a name="l00117"></a>00117 
<a name="l00124"></a>00124         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setInitialColour(<span class="keywordtype">size_t</span> chainIndex, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; col);
<a name="l00131"></a>00131         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setInitialColour(<span class="keywordtype">size_t</span> chainIndex, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> r, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> g, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> b, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> a = 1.0);
<a name="l00133"></a>00133         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; getInitialColour(<span class="keywordtype">size_t</span> chainIndex) <span class="keyword">const</span>;
<a name="l00134"></a>00134 
<a name="l00139"></a>00139         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setColourChange(<span class="keywordtype">size_t</span> chainIndex, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; valuePerSecond);
<a name="l00140"></a>00140 
<a name="l00145"></a>00145         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setInitialWidth(<span class="keywordtype">size_t</span> chainIndex, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> width);
<a name="l00147"></a>00147         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getInitialWidth(<span class="keywordtype">size_t</span> chainIndex) <span class="keyword">const</span>;
<a name="l00148"></a>00148         
<a name="l00153"></a>00153         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setWidthChange(<span class="keywordtype">size_t</span> chainIndex, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> widthDeltaPerSecond);
<a name="l00155"></a>00155         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getWidthChange(<span class="keywordtype">size_t</span> chainIndex) <span class="keyword">const</span>;
<a name="l00156"></a>00156 
<a name="l00161"></a>00161         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setColourChange(<span class="keywordtype">size_t</span> chainIndex, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> r, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> g, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> b, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> a);
<a name="l00162"></a>00162 
<a name="l00164"></a>00164         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; getColourChange(<span class="keywordtype">size_t</span> chainIndex) <span class="keyword">const</span>;
<a name="l00165"></a>00165 
<a name="l00167"></a>00167         <span class="keywordtype">void</span> nodeUpdated(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* node);
<a name="l00169"></a>00169         <span class="keywordtype">void</span> nodeDestroyed(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* node);
<a name="l00170"></a>00170 
<a name="l00172"></a>00172         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _timeUpdate(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> time);
<a name="l00173"></a>00173 
<a name="l00175"></a>00175         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getMovableType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00176"></a>00176 
<a name="l00177"></a>00177     <span class="keyword">protected</span>:
<a name="l00179"></a><a class="code" href="classOgre_1_1RibbonTrail.html#afb1089d91b94200dab252297de92bff6">00179</a>         <a class="code" href="classOgre_1_1RibbonTrail.html#a2014374dc138cc1cc5dfc21c636bd86a">NodeList</a> <a class="code" href="classOgre_1_1RibbonTrail.html#afb1089d91b94200dab252297de92bff6" title="List of nodes being trailed.">mNodeList</a>;
<a name="l00181"></a><a class="code" href="classOgre_1_1RibbonTrail.html#a5da4a331e90917db5a67dfe4e70666ba">00181</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;size_t&gt;::type</a> <a class="code" href="classOgre_1_1RibbonTrail.html#a5da4a331e90917db5a67dfe4e70666ba" title="Mapping of nodes to chain segments.">IndexVector</a>;
<a name="l00183"></a><a class="code" href="classOgre_1_1RibbonTrail.html#af7bad5fdd9ccd7d48826e5ab794cbfc3">00183</a>         <a class="code" href="classOgre_1_1RibbonTrail.html#a5da4a331e90917db5a67dfe4e70666ba" title="Mapping of nodes to chain segments.">IndexVector</a> <a class="code" href="classOgre_1_1RibbonTrail.html#af7bad5fdd9ccd7d48826e5ab794cbfc3" title="Ordered like mNodeList, contains chain index.">mNodeToChainSegment</a>;
<a name="l00184"></a>00184         <span class="comment">// chains not in use</span>
<a name="l00185"></a><a class="code" href="classOgre_1_1RibbonTrail.html#a9c60a4868baf1e4016ad312b49131a25">00185</a>         <a class="code" href="classOgre_1_1RibbonTrail.html#a5da4a331e90917db5a67dfe4e70666ba" title="Mapping of nodes to chain segments.">IndexVector</a> <a class="code" href="classOgre_1_1RibbonTrail.html#a9c60a4868baf1e4016ad312b49131a25">mFreeChains</a>;
<a name="l00186"></a>00186 
<a name="l00187"></a>00187         <span class="comment">// fast lookup node-&gt;chain index</span>
<a name="l00188"></a>00188         <span class="comment">// we use positional map too because that can be useful</span>
<a name="l00189"></a><a class="code" href="classOgre_1_1RibbonTrail.html#a2b114c3b972a06a8c4a8f202a47fcb9b">00189</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;const Node*, size_t&gt;::type</a> <a class="code" href="classOgre_1_1RibbonTrail.html#a2b114c3b972a06a8c4a8f202a47fcb9b">NodeToChainSegmentMap</a>;
<a name="l00190"></a><a class="code" href="classOgre_1_1RibbonTrail.html#a88700256a45d0cd1d273378129cf6136">00190</a>         <a class="code" href="classOgre_1_1RibbonTrail.html#a2b114c3b972a06a8c4a8f202a47fcb9b">NodeToChainSegmentMap</a> <a class="code" href="classOgre_1_1RibbonTrail.html#a88700256a45d0cd1d273378129cf6136">mNodeToSegMap</a>;
<a name="l00191"></a>00191 
<a name="l00193"></a><a class="code" href="classOgre_1_1RibbonTrail.html#a2e27fcd5f8882c24915a3a57c2938f21">00193</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1RibbonTrail.html#a2e27fcd5f8882c24915a3a57c2938f21" title="Total length of trail in world units.">mTrailLength</a>;
<a name="l00195"></a><a class="code" href="classOgre_1_1RibbonTrail.html#ac957c6bc3e57acd2e9f7067c0ac9e97b">00195</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1RibbonTrail.html#ac957c6bc3e57acd2e9f7067c0ac9e97b" title="length of each element">mElemLength</a>;
<a name="l00197"></a><a class="code" href="classOgre_1_1RibbonTrail.html#afe81aa08345ba180cb5b8e8fa3dcb220">00197</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1RibbonTrail.html#afe81aa08345ba180cb5b8e8fa3dcb220" title="Squared length of each element.">mSquaredElemLength</a>;
<a name="l00198"></a><a class="code" href="classOgre_1_1RibbonTrail.html#aa7d79db1f8751d053a36f36d69a0d040">00198</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;ColourValue&gt;::type</a> <a class="code" href="classOgre_1_1RibbonTrail.html#aa7d79db1f8751d053a36f36d69a0d040">ColourValueList</a>;
<a name="l00199"></a><a class="code" href="classOgre_1_1RibbonTrail.html#a3a9533f497a5a95e46af3b3f07892173">00199</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Real&gt;::type</a> <a class="code" href="classOgre_1_1RibbonTrail.html#a3a9533f497a5a95e46af3b3f07892173">RealList</a>;
<a name="l00201"></a><a class="code" href="classOgre_1_1RibbonTrail.html#a81cbd484158e93ce096085085b8084c8">00201</a>         <a class="code" href="classOgre_1_1RibbonTrail.html#aa7d79db1f8751d053a36f36d69a0d040">ColourValueList</a> <a class="code" href="classOgre_1_1RibbonTrail.html#a81cbd484158e93ce096085085b8084c8" title="Initial colour of the ribbon.">mInitialColour</a>;
<a name="l00203"></a><a class="code" href="classOgre_1_1RibbonTrail.html#a1a85cbdbbe427e5d5fd15f08745aa7eb">00203</a>         <a class="code" href="classOgre_1_1RibbonTrail.html#aa7d79db1f8751d053a36f36d69a0d040">ColourValueList</a> <a class="code" href="classOgre_1_1RibbonTrail.html#a1a85cbdbbe427e5d5fd15f08745aa7eb" title="fade amount per second">mDeltaColour</a>;
<a name="l00205"></a><a class="code" href="classOgre_1_1RibbonTrail.html#acc6feaf49b66d518ade88f864c1b2f6c">00205</a>         <a class="code" href="classOgre_1_1RibbonTrail.html#a3a9533f497a5a95e46af3b3f07892173">RealList</a> <a class="code" href="classOgre_1_1RibbonTrail.html#acc6feaf49b66d518ade88f864c1b2f6c" title="Initial width of the ribbon.">mInitialWidth</a>;
<a name="l00207"></a><a class="code" href="classOgre_1_1RibbonTrail.html#a7769b9f130416658b57c98b93809635c">00207</a>         <a class="code" href="classOgre_1_1RibbonTrail.html#a3a9533f497a5a95e46af3b3f07892173">RealList</a> <a class="code" href="classOgre_1_1RibbonTrail.html#a7769b9f130416658b57c98b93809635c" title="Delta width of the ribbon.">mDeltaWidth</a>;
<a name="l00209"></a><a class="code" href="classOgre_1_1RibbonTrail.html#aa1a0246aa7751805204a54bf05e9cb2a">00209</a>         <a class="code" href="classOgre_1_1Controller.html">Controller&lt;Real&gt;</a>* <a class="code" href="classOgre_1_1RibbonTrail.html#aa1a0246aa7751805204a54bf05e9cb2a" title="controller used to hook up frame time to fader">mFadeController</a>;
<a name="l00211"></a><a class="code" href="classOgre_1_1RibbonTrail.html#a1008ba868a30029cc380f0e62a5e1a37">00211</a>         <a class="code" href="classOgre_1_1SharedPtr.html">ControllerValueRealPtr</a> <a class="code" href="classOgre_1_1RibbonTrail.html#a1008ba868a30029cc380f0e62a5e1a37" title="controller value for hooking up frame time to fader">mTimeControllerValue</a>;
<a name="l00212"></a>00212 
<a name="l00214"></a>00214         <span class="keyword">virtual</span> <span class="keywordtype">void</span> manageController(<span class="keywordtype">void</span>);
<a name="l00216"></a>00216         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateTrail(<span class="keywordtype">size_t</span> index, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* node);
<a name="l00218"></a>00218         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resetTrail(<span class="keywordtype">size_t</span> index, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* node);
<a name="l00220"></a>00220         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resetAllTrails(<span class="keywordtype">void</span>);
<a name="l00221"></a>00221 
<a name="l00222"></a>00222     };
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00226"></a><a class="code" href="classOgre_1_1RibbonTrailFactory.html">00226</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RibbonTrailFactory.html" title="Factory object for creating RibbonTrail instances.">RibbonTrailFactory</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1MovableObjectFactory.html" title="Interface definition for a factory class which produces a certain kind of MovableObject, and can be registered with Root in order to allow all clients to produce new instances of this object, integrated with the standard Ogre processing.">MovableObjectFactory</a>
<a name="l00227"></a>00227     {
<a name="l00228"></a>00228     <span class="keyword">protected</span>:
<a name="l00229"></a>00229         <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* createInstanceImpl( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a>* params);
<a name="l00230"></a>00230     <span class="keyword">public</span>:
<a name="l00231"></a><a class="code" href="classOgre_1_1RibbonTrailFactory.html#a7d176d9fe51e17fdacf2aadd43305c34">00231</a>         <a class="code" href="classOgre_1_1RibbonTrailFactory.html#a7d176d9fe51e17fdacf2aadd43305c34">RibbonTrailFactory</a>() {}
<a name="l00232"></a><a class="code" href="classOgre_1_1RibbonTrailFactory.html#afa15dea351429a75bc3e1c3322133489">00232</a>         <a class="code" href="classOgre_1_1RibbonTrailFactory.html#afa15dea351429a75bc3e1c3322133489">~RibbonTrailFactory</a>() {}
<a name="l00233"></a>00233 
<a name="l00234"></a><a class="code" href="classOgre_1_1RibbonTrailFactory.html#a0cf4339e9003458669f6d3fc06aa0bef">00234</a>         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1RibbonTrailFactory.html#a0cf4339e9003458669f6d3fc06aa0bef">FACTORY_TYPE_NAME</a>;
<a name="l00235"></a>00235 
<a name="l00236"></a>00236         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00237"></a>00237         <span class="keywordtype">void</span> destroyInstance( <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* obj);  
<a name="l00238"></a>00238 
<a name="l00239"></a>00239     };
<a name="l00243"></a>00243 }
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
